<template>
  <div class="editable-field" :class="{ edit: isEditable }">
    <input
      v-bind="$attrs"
      ref="input"
      :readonly="readonly"
      @input="$emit('input', $event.target.value)"
    />
    <button
      type="button"
      class="btn-edit"
      aria-label="Edit"
      @click="changeMode"
    >
      <i :class="iconClass" />
    </button>
  </div>
</template>

<script>
export default {
  name: 'InputEditable',
  inheritAttrs: false,
  data() {
    return {
      isEditable: false,
    }
  },
  computed: {
    readonly() {
      return !this.isEditable
    },
    iconClass() {
      return this.isEditable ? 'icon-edit' : 'icon-lock'
    },
  },
  methods: {
    changeMode() {
      this.isEditable = !this.isEditable
      if (this.isEditable) {
        this.$refs.input.focus()
      }
    },
    setMode(isEditable) {
      this.isEditable = isEditable
    },
  },
}
</script>
